#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <math.h>
#include <time.h>

#define pi2 6.28318530718 /* 2 pi */
#define e2suhbar 3.0386E15  // 2e/h_bar in MKS 

#define NEQ 2
double f(double x, double y[], int i);
#include "c:\msdev\projects\RK4\rk4.c"

FILE *output;

double mesh,pst_mean,pst_trans,i0min,i0max,i0delta,sweep;
double I_c;
double R_normal, R_subgap;
double BetaC_normal,BetaC_subgap;
double V_gap,V_depth,C_normal;
double v_gap,v_depth;
double omega_p,omega_c;
double I_norm,V_norm;
double V_c,V_p;
double t_norm;

double i1,omega1,Omega1;
double i,i0;
int n_rf;

double (*BetaC) (double v);
double BetaC_Rcostante(double v);
double BetaC_Rspezzata(double v);
double BetaC_Rcontinua(double v);

void main()
{
double tau, y[2], v_mean, vpst_mean, vpst_trans;
double i0min_sweep, i0max_sweep, sweep_shift;
long k,npst_mean,npst_trans,npst_total;
char tmpbuf[128];
char *banner_metodo[] = {"Runge-Kutta IV ordine","Adams III ordine","Adams IV ordine","Adams-Moulton V ordine","Adams-Moulton VI ordine"};
char *banner_R[] = {"R costante"," R spezzata","R continua"};
char *banner_cnd[] = {"Random", "Continuo da zero"};
char *banner_ping[] = {"Solo salita", "Salita e discesa"};
int n_metodo,n_cnd,n_ping = 0,n_r,n_outv,n_i;//,n_modello,n_proc;
void (*f_metodo) (double x, double y[], double h);

printf("Nome file su cui scrivere caratteristica <I> vs <V> ? ");
scanf("%s",tmpbuf);
output=fopen(tmpbuf, "w");

/*
printf("0 = RCSJN, 1 = RCSJ\n");
printf("Modello giunzione Josephson ? ");
scanf("%d",&n_modello);
if(n_modello == 1)
	{
	printf("0 = No, 1 = Si\n");
	printf("Procedura normalizzata alla pulsazione caratteristica ? ");
	scanf("%d",&n_proc);
	if(n_proc == 1)
		{

		}
	}
*/

printf("-- Parametri giunzione Josephson --\n");
printf("1 == 1 mA\n");
printf("Corrente critica ? ");
scanf("%lf",&I_c);
printf("1 == 1 pF\n");
printf("Capacita' ? ");
scanf("%lf",&C_normal);
omega_p = sqrt(e2suhbar*I_c*1E9/C_normal);
printf("Pulsazione di plasma (rad/s) = %e\n",omega_p);
printf("0 = costante, 1 = spezzata, 2 = continua\n");
printf("Approssimazione R ? ");
scanf("%d",&n_r);
switch(n_r)
	{
	case 2:
		printf("1 == 1mV\n");
		printf("Tensione di gap depth ? ");
		scanf("%lf",&V_depth);
	case 1:
		printf("1 == 1 mV\n");
		printf("Tensione di gap ? ");
		scanf("%lf",&V_gap);
		printf("1 == 1 Ohm\n");
		printf("R_subgap ? ");
		scanf("%lf",&R_subgap);
		printf("R_normal ? ");
		scanf("%lf",&R_normal);
		BetaC_subgap = e2suhbar*R_subgap*R_subgap*C_normal*I_c*1E-15;
		BetaC_normal = e2suhbar*R_normal*R_normal*C_normal*I_c*1E-15;
		printf("BetaC_subgap = %lf, BetaC_normal = %lf\n",BetaC_subgap,BetaC_normal);
		break;
	case 0:
		printf("1 == 1 Ohm\n");
		printf("R_normal ? ");
		scanf("%lf",&R_normal);
		omega_c = e2suhbar*R_normal*I_c*1E-3;
		V_c = 1E3*omega_c/e2suhbar;
		printf("Pulsazione caratteristica (rad/s) = %e\n",omega_c);
		BetaC_normal = e2suhbar*R_normal*R_normal*C_normal*I_c*1E-15;
		printf("BetaC_normal = %lf\n",BetaC_normal);
		break;
	}

switch(n_r)
	{
	case 0 : BetaC = &BetaC_Rcostante; break;
	case 1 : BetaC = &BetaC_Rspezzata; break;
	case 2 : BetaC = &BetaC_Rcontinua; break;
	}

V_p = 1E3*omega_p/e2suhbar;
v_gap = V_gap/V_p;
v_depth = V_depth/V_p;

printf("-- Parametri polarizzazione --\n");
printf("0 = No, 1 = Si\n");
printf("Inserire rf ? ");
scanf("%d",&n_rf);
if(n_rf == 1)
	{
	printf("1 == 1 GHz\n");
	printf("Frequenza rf ? ");
	scanf("%lf",&omega1);
	omega1 *= pi2*1E9;
	Omega1 = omega1/omega_p;
	printf("Pulsazione normalizzata alla pulsazione di plasma %lf\n",Omega1);
	if(n_r == 0)
		printf("Pulsazione normalizzata alla pulsazione caratteristica %lf\n",omega1/omega_c);
	printf("Step armonici in corrispondenza di %lf mV (normalizzato %lf)\n",Omega1*V_norm,Omega1);
	
	printf("1 == 1 mA\n");
	printf("Ampiezza rf ? ");
	scanf("%lf",&i1);
	i1 /= I_c;
	}

printf("-- Parametri integrazione numerica --\n");
printf("1 == 1/(pulsazione di plasma)\n");
printf("Lunghezza di mesh (rad) ? ");
scanf("%lf",&mesh);
printf("Metodo di integrazione (0 == Runge-Kutta IV, 1 == Adams III, 2 == Adams IV, 3 == Adams-Moulton V, 4 == Adams-Moulton VI) ? ");
scanf("%d",&n_metodo);
switch(n_metodo)
	{
	case 0: f_metodo = &RK4; break;
	case 1: f_metodo = &Adams3; break;
	case 2: f_metodo = &Adams4; break;
	case 3: f_metodo = &AdamsMoulton5; break;
	case 4: f_metodo = &AdamsMoulton6; break;
	}

printf("-- Parametri media della tensione --\n");
printf("1 == 1 /(pulsazione di plasma) \n");
printf("Tempo su cui mediare (rad) ? ");
scanf("%lf",&pst_mean);
printf("Tempo da scartare come transiente (rad) ? ");
scanf("%lf",&pst_trans);

npst_mean  = (int)(pst_mean/mesh+0.5);
vpst_mean  = ((double)(npst_mean))*mesh;
npst_trans = (int)(pst_trans/mesh+0.5);
vpst_trans = ((double)(npst_trans))*mesh;
npst_total = npst_mean+npst_trans;
printf("Media su %lf rad (%d mesh steps) dopo transiente di %lf rad (%d mesh steps)\n",vpst_mean,npst_mean,vpst_trans,npst_trans);

printf("-- Parametri caratteristica --\n");
printf("1 == 1 mA\n");
printf("Corrente minima ? ");
scanf("%lf",&i0min);
i0min /=I_c;
printf("Corrente massima ? ");
scanf("%lf",&i0max);
i0max /= I_c;
printf("Delta corrente ? ");
scanf("%lf",&i0delta);
i0delta /= I_c;

printf("-- Condizioni iniziali --\n");
printf("0 = Random, 1 = Continuo da zero\n");
scanf("%d",&n_cnd);

if(n_cnd == 0)
	{
	printf("-- Parametri Sweep di corrente --\n");
	printf("Numero cicli di sweep ? ");
	scanf("%lf",&sweep);
	}
else
	{
	sweep = 1;
	printf("Modalita' sweep\n");
	printf("0 = Solo salita, 1 = Salita e discesa\n");
	scanf("%d",&n_ping);
	}

printf("-- Generazione output --\n");
if(n_r == 0)
	{
	printf("0 = nessuna, 1 = tensione di plasma , 2 = tensione caratteristica\n");
	printf("Normalizzazione tensione ? ");
	scanf("%d",&n_outv);
	}
else
	{
	printf("0 = nessuna, 1 = tensione di plasma\n");
	printf("Normalizzazione tensione ? ");
	scanf("%d",&n_outv);
	}
printf("0 = nessuna, 1 = corrente critica\n");
printf("Normalizzazione corrente ? ");
scanf("%d",&n_i);
switch(n_i)
	{
	case 0 : I_norm = I_c; break;
	case 1 : I_norm = 1; break;
	}
switch(n_outv)
	{
	case 0 : V_norm = V_p; break;
	case 1 : V_norm = 1; break;
	case 2 : V_norm = 1/sqrt(BetaC_normal); break;
	}

_strdate(tmpbuf);
fprintf(output,"# Data: %s\n",tmpbuf);
fprintf(output,"# Caratteristica IV giunzione Josephson\n");
fprintf(output,"# Integrazione numerica via metodo di %s\n",banner_metodo[n_metodo]);
fprintf(output,"# Mesh length = %lf rad\n",mesh);
fprintf(output,"# Modello utilizzato: %s con\n",banner_R[n_r]);
switch(n_r)
	{
	case 2:fprintf(output,"# Tensione di gap V_gap (mV) = %lf, Gap depth V_depth (mV) = %lf\n",V_gap,V_depth);
	case 1:fprintf(output,"# R_subgap (Ohm) = %lf\n",R_subgap);
	case 0:fprintf(output,"# R_normal (Ohm) = %lf\n",R_normal);
	}
fprintf(output,"# Capacita' C (pF) = %lf\n",C_normal);
fprintf(output,"# Corrente critica (mA) = %lf\n",I_c);
fprintf(output,"# Pulsazione di plasma (rad/s) = %e\n",omega_p);
if(n_r>0)
	fprintf(output,"# BetaC_subgap = %lf, BetaC_normal = %lf\n",BetaC_subgap,BetaC_normal);
else
	{
	fprintf(output,"# Pulsazione caratteristica (rad/s) = %e\n", omega_c);
	fprintf(output,"# BetaC_normal = %lf\n",BetaC_normal);
	}
fprintf(output,"# Normalizzazione: V_norm = %lf, I_norm = I_c = %lf\n",V_norm,I_norm);
if(n_rf == 1)
	fprintf(output,"# RF I1 = %lf, Omega1 = %lf\n",i1,Omega1);
fprintf(output,"# Tensione mediata su %lf rad (%d mesh steps)\n# scartato un transiente di %lf rad (%d mesh steps)\n",vpst_mean,npst_mean,vpst_trans,npst_trans);
fprintf(output,"# I0 = [%lf,%lf], DeltaI0 = %lf\n",i0min,i0max,i0delta);
fprintf(output,"# Cnd iniziali = %s\n",banner_cnd[n_cnd]);
fprintf(output,"# Numero di sweep = %d\n",sweep);
fprintf(output,"# Modalita' sweep = %s\n",banner_ping[n_ping]);

srand((unsigned)time(NULL));

fprintf(output,"#\n# -- Simulazione iniziata...\n");

sweep_shift = i0delta/sweep;

for(k=0;k<sweep;k++)
 {
 _strtime(tmpbuf);
 printf("Ore: %s\n",tmpbuf);
 printf("Sweep numero %d.\n",k+1);
 fprintf(output,"#\n# -- Ore %s\n# -- Sweep numero %d\n# I-<V>\n",tmpbuf,k+1);
 i0min_sweep = i0min + k*sweep_shift;
 i0max_sweep = i0max + k*sweep_shift;
 
 y[0] = 0;
 y[1] = 0;
 
 if(n_metodo != 0)
  Adams_start(0.0,y,mesh);

 for(i0=i0min_sweep;i0<=i0max_sweep;i0+=i0delta)
  {
  if(n_cnd == 0)
   {
   y[0]= pi2*rand()/RAND_MAX;
   y[1]= 2.0*(rand()-RAND_MAX/2)/RAND_MAX;
   if(n_metodo != 0)
    Adams_start(0.0,y,mesh);
   }
  v_mean = 0.0;
  for(tau=0.0; tau<=vpst_trans; tau+=mesh)
   (*f_metodo)(tau,y,mesh);
  for(tau=vpst_trans; tau<=vpst_mean+vpst_trans ; tau+=mesh)
   {
   (*f_metodo)(tau,y,mesh);
   v_mean += y[1];
   }
  v_mean /= npst_mean;

  fprintf(output, "%.10lf\t%.10lf\n",i0*I_norm,v_mean*V_norm);
  }

if(n_ping == 1) 
 {
 for(i0=i0max_sweep;i0>=i0min_sweep;i0-=i0delta)
  {
  if(n_cnd == 0)
   {
   y[0]= pi2*rand()/RAND_MAX;
   y[1]= 2.0*(rand()-RAND_MAX/2)/RAND_MAX;
   }
  if(n_metodo == 1)
   Adams_start(0.0,y,mesh);
  v_mean = 0.0;
  for(tau=0.0; tau<=vpst_trans; tau+=mesh)
   (*f_metodo)(tau,y,mesh);
  for(tau=vpst_trans; tau<=vpst_mean+vpst_trans ; tau+=mesh)
   {
   (*f_metodo)(tau,y,mesh);
   v_mean += y[1];
   }
  v_mean /= vpst_mean/mesh;

  fprintf(output, "%.10lf\t%.10lf\n",i0*I_norm,v_mean*V_norm);
  }
 }
}

_strtime(tmpbuf);
printf("Finito! Ore: %s\n",tmpbuf);
 
fclose(output);
}

double BetaC_Rcostante(double v)
{
 return(BetaC_normal);
}

double BetaC_Rspezzata(double v)
{
return((fabs(v)<=v_gap) ? BetaC_subgap : BetaC_normal);
}

double BetaC_Rcontinua(double v)
{
 double G;

 G = 1/R_subgap+(1/R_normal-1/R_subgap)/(1+exp((v_gap-fabs(v))/v_depth));

 return(e2suhbar*C_normal*I_c*1E-15/(G*G));
}

/* Polarizzazione con corrente i*/
double f(double x, double y[], int j)
{
i = (n_rf == 0) ? i0 : i0+ i1*sin(Omega1*x);
switch(j)
	{
	case 0: return(y[1]);
	case 1: return(i-y[1]/sqrt((*BetaC)(y[1]))-sin(y[0]));
	};
}
