#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <math.h>
#include <time.h>

#define pi2 6.28318530718 /* 2 pi */

#define NEQ 6
double f(double x, double y[], int i);
#include "c:\msdev\projects\RK4\rk4.c"

FILE *output;

double mesh,pst_mean,pst_trans,i0min,i0max,i0delta,sweep;
double BetaC;
double i1, Omega1;

double i0;

void main()
{
double tau, tau1,y[6],csinorm[2],csiproj,lyapphi,lyapv,vpst_mean, vpst_trans,phi0,v0;
double i0min_sweep, i0max_sweep, sweep_shift;
long p,p1,k,npst_mean,npst_trans,npst_total;
char tmpbuf[128],*banner_metodo[] = {"Runge-Kutta quarto ordine","Adams"};
int  n_metodo,nrf_trans,nrf_mean;
void (*f_metodo) (double x, double y[], double h);

printf("Nome file su cui scrivere spettro di Lyapunov ? ");
scanf("%s",tmpbuf);
output=fopen(tmpbuf, "w");

printf("-- Parametri giunzione Josephson --\n");
printf("BetaC ? ");
scanf("%lf",&BetaC);

printf("-- Parametri polarizzazione --\n");
printf("1 == 1 pulsazione caratteristica di Josephson\n");
printf("Omega1 ? ");
scanf("%lf",&Omega1);
printf("1 == 1 Ic == 1 corrente critica giunzione Josephson\n");
printf("I1 ?");
scanf("%lf",&i1);

printf("-- Parametri integrazione numerica --\n");
printf("1 == 1 rad == 1/(pulsazione caratteristica di Josephson)\n");
printf("Lunghezza di mesh ? ");
scanf("%lf",&mesh);
printf("0 = Runge-Kutta, 1 = Adams\n");
printf("Metodo di integrazione ? ");
scanf("%d",&n_metodo);
switch(n_metodo)
	{
	case 0: f_metodo = &RK4; break;
	case 1: f_metodo = &Adams; break;
	}

tau1= pi2/Omega1;
printf("-- Parametri registrazione tensione --\n");
printf("1 = 1 ciclo rf == 2*Pi/(Omega1) rad = %lf rad\n",tau1);
printf("Cicli rf da scartare come transiente ? ");
scanf("%d",&nrf_trans);
printf("Cicli rf su cui registrare ? ");
scanf("%d",&nrf_mean);

pst_mean = tau1*nrf_mean;
pst_trans = tau1*nrf_trans;
npst_mean  = (int)(pst_mean/mesh+0.5);
vpst_mean  = ((double)(npst_mean))*mesh;
npst_trans = (int)(pst_trans/mesh+0.5);
vpst_trans = ((double)(npst_trans))*mesh;
npst_total = npst_mean+npst_trans;
printf("Registro su %lf rad (%d mesh steps) dopo transiente di %lf rad (%d mesh steps)\n",vpst_mean,npst_mean,vpst_trans,npst_trans);

printf("-- Parametri caratteristica --\n");
printf("1 == 1 Ic == 1 corrente critica giunzione Josephson\n");
printf("Corrente minima ? ");
scanf("%lf",&i0min);
printf("Corrente massima ? ");
scanf("%lf",&i0max);
printf("Delta corrente ? ");
scanf("%lf",&i0delta);

printf("-- Parametri Sweep di corrente --\n");
printf("Numero cicli di sweep ? ");
scanf("%lf",&sweep);

_strdate(tmpbuf);
fprintf(output,"# Data: %s\n",tmpbuf);
fprintf(output,"# Spettro di Lyapunov giunzione Josephson\n");
fprintf(output,"# Integrazione numerica via metodo di %s\n",banner_metodo[n_metodo]);
fprintf(output,"# BetaC = %lf\n",BetaC);
fprintf(output,"# I1 = %lf, Omega1 = %lf\n",i1,Omega1);
fprintf(output,"# Mesh length = %lf rad\n",mesh);
fprintf(output,"# Tensione registrata per %lf rad (%d mesh steps)\n# scartato un transiente di %lf rad (%d mesh steps)\n",vpst_mean,npst_mean,vpst_trans,npst_trans);
fprintf(output,"# I0 = [%lf,%lf], DeltaI0 = %lf\n",i0min,i0max,i0delta);
fprintf(output,"# Numero di sweep = %lf\n",sweep);

srand((unsigned)time(NULL));

fprintf(output,"#\n# -- Simulazione iniziata...\n");

sweep_shift = i0delta/sweep;

p1=(int)(tau1/mesh+0.5);

for(k=0;k<sweep;k++)
 {
 _strtime(tmpbuf);
 printf("Ore: %s\n",tmpbuf);
 printf("Sweep numero %d.\n",k+1);
 fprintf(output,"#\n# -- Ore %s\n# -- Sweep numero %d\n# I0-Lyap(phi)-Lyap(v)-Lyap(phi)+Lyap(v)\n",tmpbuf,k+1);
 i0min_sweep = i0min + k*sweep_shift;
 i0max_sweep = i0max + k*sweep_shift;
 
 for(i0=i0min_sweep;i0<=i0max_sweep;i0+=i0delta)
  {
  phi0 = y[0]= 0;
  v0   = y[1]= 0;
  y[2] = 1;
  y[3] = 0;
  y[4] = 0;
  y[5] = 1;
  lyapphi = 0;
  lyapv = 0;
  p = 0;
  if(n_metodo == 1)
	  Adams_start(0.0,y,mesh);
  //for(tau=0.0; tau<=vpst_trans; tau+=mesh)
  //   (*f_metodo)(tau,y,mesh);
  for(tau=0.0; tau<=vpst_mean; tau+=mesh)
   {
   (*f_metodo)(tau,y,mesh);
   /* Gram-Schmidt */
   csinorm[0] = sqrt(y[2]*y[2]+y[3]*y[3]);
   y[2] /= csinorm[0]; y[3] /= csinorm[0];
   csiproj = y[4]*y[2]+y[5]*y[3];
   y[4] -= csiproj*y[2]; y[5] -= csiproj*y[3];
   csinorm[1] = sqrt(y[4]*y[4]+y[5]*y[5]);
   y[4] /= csinorm[1]; y[5] /= csinorm[1];
   
   lyapphi += log(csinorm[0]);
   lyapv += log(csinorm[1]);
     
   p++;
   }
  lyapphi /= vpst_mean;
  lyapv /= vpst_mean;
  fprintf(output, "%.10lf\t%.10lf\t%.10lf\t%.10lf\n",i0,lyapphi,lyapv,lyapphi+lyapv);
 }
 }

fclose(output);
}

/* Polarizzazione con corrente i0+i1*sin(Omega1*tau) */
double f(double x, double y[], int i)
{
switch(i)
	{
	case 0: return(y[1]);
	case 1: return((i0+i1*sin(Omega1*x)-y[1]-sin(y[0]))/BetaC);
	/* Sistema linearizzato.*/
	case 2: return(y[3]);
	case 3: return(-(y[2]*cos(y[0])+y[3])/BetaC);
	case 4: return(y[5]);
	case 5: return(-(y[4]*cos(y[0])+y[5])/BetaC);
	};
}
