#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <math.h>
#include <time.h>

#define pi2 6.28318530718 /* 2 pi */

#define NEQ 2
double f(double x, double y[], int i);
#include "c:\msdev\projects\RK4\rk4.c"

FILE *output;

double mesh,pst_mean,pst_trans,i0min,i0max,i0delta,sweep;
double BetaC;
double i1, Omega1;

double i0;

void main()
{
double tau, y[2], v_mean, vpst_mean, vpst_trans, phi0, v0;
double i0min_sweep, i0max_sweep, sweep_shift;
long k,npst_mean,npst_trans,npst_total;
char tmpbuf[128];
char *banner_metodo[] = {"Runge-Kutta IV ordine","Adams III ordine","Adams IV ordine","Adams-Moulton V ordine","Adams-Moulton VI ordine"};
char *banner_cnd[] = {"Random", "Continuo da zero"};
char *banner_ping[] = {"Solo salita", "Ping pong"};
int n_metodo,n_cnd,n_ping;
void (*f_metodo) (double x, double y[], double h);

printf("Nome file su cui scrivere caratteristica <I> vs <V> ? ");
scanf("%s",tmpbuf);
output=fopen(tmpbuf, "w");

printf("-- Parametri giunzione Josephson --\n");
printf("BetaC ? ");
scanf("%lf",&BetaC);

printf("-- Parametri polarizzazione --\n");
printf("1 == 1 pulsazione caratteristica di Josephson\n");
printf("Omega1 ? ");
scanf("%lf",&Omega1);
printf("1 == 1 Ic == 1 corrente critica giunzione Josephson\n");
printf("I1 ?");
scanf("%lf",&i1);

printf("-- Parametri integrazione numerica --\n");
printf("1 == 1 rad == 1/(pulsazione caratteristica di Josephson)\n");
printf("Lunghezza di mesh ? ");
scanf("%lf",&mesh);
printf("Metodo di integrazione (0 == Runge-Kutta IV, 1 == Adams III, 2 == Adams IV, 3 == Adams-Moulton V, 4 == Adams-Moulton VI) ? ");
scanf("%d",&n_metodo);
switch(n_metodo)
	{
	case 0: f_metodo = &RK4; break;
	case 1: f_metodo = &Adams3; break;
	case 2: f_metodo = &Adams4; break;
	case 3: f_metodo = &AdamsMoulton5; break;
	case 4: f_metodo = &AdamsMoulton6; break;
	}

printf("-- Parametri media della tensione --\n");
printf("1 == 1 rad == 1/(pulsazione caratteristica di Josephson)\n");
printf("Tempo su cui mediare (rad) ? ");
scanf("%lf",&pst_mean);
printf("Tempo da scartare come transiente (rad) ? ");
scanf("%lf",&pst_trans);

npst_mean  = (int)(pst_mean/mesh+0.5);
vpst_mean  = ((double)(npst_mean))*mesh;
npst_trans = (int)(pst_trans/mesh+0.5);
vpst_trans = ((double)(npst_trans))*mesh;
npst_total = npst_mean+npst_trans;
printf("Media su %lf rad (%d mesh steps) dopo transiente di %lf rad (%d mesh steps)\n",vpst_mean,npst_mean,vpst_trans,npst_trans);

printf("-- Parametri caratteristica --\n");
printf("1 == 1 Ic == 1 corrente critica giunzione Josephson\n");
printf("Corrente minima ? ");
scanf("%lf",&i0min);
printf("Corrente massima ? ");
scanf("%lf",&i0max);
printf("Delta corrente ? ");
scanf("%lf",&i0delta);

printf("-- Condizioni iniziali --\n");
printf("0 = Random, 1 = Continuo da zero\n");
scanf("%d",&n_cnd);

printf("-- Parametri Sweep di corrente --\n");
printf("Numero cicli di sweep ? ");
scanf("%lf",&sweep);
if(n_cnd == 1)
	{
	printf("Modalita' sweep\n");
	printf("0 = Solo salita, 1 = Ping pong\n");
	scanf("%d",&n_ping);
	}

_strdate(tmpbuf);
fprintf(output,"# Data: %s\n",tmpbuf);
fprintf(output,"# Caratteristica IV giunzione Josephson\n");
fprintf(output,"# Integrazione numerica via metodo di %s\n",banner_metodo[n_metodo]);
fprintf(output,"# BetaC = %lf\n",BetaC);
fprintf(output,"# I1 = %lf, Omega1 = %lf\n",i1,Omega1);
fprintf(output,"# Mesh length = %lf rad\n",mesh);
fprintf(output,"# Tensione mediata su %lf rad (%d mesh steps)\n# scartato un transiente di %lf rad (%d mesh steps)\n",vpst_mean,npst_mean,vpst_trans,npst_trans);
fprintf(output,"# I0 = [%lf,%lf], DeltaI0 = %lf\n",i0min,i0max,i0delta);
fprintf(output,"# Cnd iniziali = %s\n",banner_cnd[n_cnd]);
fprintf(output,"# Numero di sweep = %d\n",sweep);
fprintf(output,"# Modalita' sweep = %s\n",banner_ping[n_ping]);

srand((unsigned)time(NULL));

fprintf(output,"#\n# -- Simulazione iniziata...\n");

sweep_shift = i0delta/sweep;

for(k=0;k<sweep;k++)
 {
 _strtime(tmpbuf);
 printf("Ore: %s\n",tmpbuf);
 printf("Sweep numero %d.\n",k+1);
 fprintf(output,"#\n# -- Ore %s\n# -- Sweep numero %d\n# I0-V media-phi(0)-v(0)\n",tmpbuf,k+1);
 i0min_sweep = i0min + k*sweep_shift;
 i0max_sweep = i0max + k*sweep_shift;
 
 phi0 = y[0] = 0;
 v0 = y[1] = 0;

 if(n_metodo != 0)
  Adams_start(0.0,y,mesh);

 for(i0=i0min_sweep;i0<=i0max_sweep;i0+=i0delta)
  {
  if(n_cnd == 0)
   {
   phi0 = y[0]= pi2*rand()/RAND_MAX;
   v0   = y[1]= 2.0*(rand()-RAND_MAX/2)/RAND_MAX;
   if(n_metodo != 0)
    Adams_start(0.0,y,mesh);
   }
  v_mean = 0.0;
  for(tau=0.0; tau<=vpst_trans; tau+=mesh)
   (*f_metodo)(tau,y,mesh);
  for(tau=vpst_trans; tau<=vpst_mean+vpst_trans ; tau+=mesh)
   {
   (*f_metodo)(tau,y,mesh);
   v_mean += y[1];
   }
  v_mean /= vpst_mean/mesh;

  fprintf(output, "%.10lf\t%.10lf\t%.10lf\t%.10lf\n",i0,v_mean,phi0,v0);
  }

if(n_ping == 1) 
 {
 for(i0=i0max_sweep;i0>=i0min_sweep;i0-=i0delta)
  {
  if(n_cnd == 0)
   {
   phi0 = y[0]= pi2*rand()/RAND_MAX;
   v0   = y[1]= 2.0*(rand()-RAND_MAX/2)/RAND_MAX;
   }
  if(n_metodo == 1)
   Adams_start(0.0,y,mesh);
  v_mean = 0.0;
  for(tau=0.0; tau<=vpst_trans; tau+=mesh)
   (*f_metodo)(tau,y,mesh);
  for(tau=vpst_trans; tau<=vpst_mean+vpst_trans ; tau+=mesh)
   {
   (*f_metodo)(tau,y,mesh);
   v_mean += y[1];
   }
  v_mean /= vpst_mean/mesh;

  fprintf(output, "%.10lf\t%.10lf\t%.10lf\t%.10lf\n",i0,v_mean,phi0,v0);
  }
 }
}

_strtime(tmpbuf);
printf("Finito! Ore: %s\n",tmpbuf);
 
fclose(output);
}

/* Polarizzazione con corrente i0+i1*sin(Omega1*tau) */
double f(double x, double y[], int i)
{
switch(i)
	{
	case 0: return(y[1]);
	case 1: return((i0+i1*sin(Omega1*x)-y[1]-sin(y[0]))/BetaC);
	};
}
