#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <math.h>
#include <time.h>

#define pi2 6.28318530718 /* 2 pi */

#define NEQ 2
double f(double x, double y[], int i);
#include "c:\msdev\projects\RK4\rk4.c"

FILE *output;

double mesh,pst_mean,pst_trans;
double BetaC;
double i1, Omega1;

double i0;

void main()
{
double tau, tau1,y[2], vpst_mean, vpst_trans, phi0, v0;
long p,p1,npst_mean,npst_trans,npst_total;
char tmpbuf[128],*banner_metodo[] = {"Runge-Kutta quarto ordine","Adams"};
int  n_iniziali,n_metodo,nrf_trans,nrf_mean;
void (*f_metodo) (double x, double y[], double h);

printf("Nome file su cui scrivere traiettoria phi e v ? ");
scanf("%s",tmpbuf);
output=fopen(tmpbuf, "w");

printf("-- Parametri giunzione Josephson --\n");
printf("BetaC ? ");
scanf("%lf",&BetaC);

printf("-- Parametri polarizzazione --\n");
printf("1 == 1 pulsazione caratteristica di Josephson\n");
printf("Omega1 ? ");
scanf("%lf",&Omega1);
printf("1 == 1 Ic == 1 corrente critica giunzione Josephson\n");
printf("I1 ?");
scanf("%lf",&i1);
printf("I0 ? ");
scanf("%lf",&i0);

printf("-- Parametri integrazione numerica --\n");
printf("1 == 1 rad == 1/(pulsazione caratteristica di Josephson)\n");
printf("Lunghezza di mesh ? ");
scanf("%lf",&mesh);
printf("0 = Runge-Kutta, 1 = Adams\n");
printf("Metodo di integrazione ? ");
scanf("%d",&n_metodo);
switch(n_metodo)
	{
	case 0: f_metodo = &RK4; break;
	case 1: f_metodo = &Adams; break;
	}

tau1= pi2/Omega1;
printf("-- Parametri registrazione traiettoria --\n");
printf("1 = 1 ciclo rf == 2*Pi/(Omega1) rad = %lf rad\n",tau1);
printf("Cicli rf da scartare come transiente ? ");
scanf("%d",&nrf_trans);
printf("Cicli rf su cui registrare ? ");
scanf("%d",&nrf_mean);

pst_mean = tau1*nrf_mean;
pst_trans = tau1*nrf_trans;
npst_mean  = (int)(pst_mean/mesh+0.5);
vpst_mean  = ((double)(npst_mean))*mesh;
npst_trans = (int)(pst_trans/mesh+0.5);
vpst_trans = ((double)(npst_trans))*mesh;
npst_total = npst_mean+npst_trans;
printf("Registro su %lf rad (%d mesh steps) dopo transiente di %lf rad (%d mesh steps)\n",vpst_mean,npst_mean,vpst_trans,npst_trans);

_strdate(tmpbuf);
fprintf(output,"# Data: %s\n",tmpbuf);
fprintf(output,"# Traiettoria phi(tau)-V(tau) per tau=k*2*Pi/Omega1 giunzione Josephson polarizzata con corrente i0+i1*sin(Omega1*tau)\n");
fprintf(output,"# Integrazione numerica via metodo di %s\n",banner_metodo[n_metodo]);
fprintf(output,"# BetaC = %lf\n",BetaC);
fprintf(output,"# I0 = %lf, I1 = %lf, Omega1 = %lf\n",i0,i1,Omega1);
fprintf(output,"# Mesh length = %lf rad\n",mesh);
fprintf(output,"# Traiettoria registrata per %lf rad (%d mesh steps)\n# scartato un transiente di %lf rad (%d mesh steps)\n",vpst_mean,npst_mean,vpst_trans,npst_trans);
fprintf(output,"# Tau\t phi(Tau)\t v(Tau)\t phi(Tau) mod 2Pi\n");

p1=(int)(tau1/mesh+0.5);

printf("Valori iniziali (0 == Random, 1 == Immettere, 2 == [0,0])?\n");
scanf("%d",&n_iniziali);
switch(n_iniziali)
	{
	case 0:
		srand((unsigned)time(NULL));
		phi0 = pi2*rand()/RAND_MAX;
		v0   = 2.0*(rand()-RAND_MAX/2)/RAND_MAX;
		break;
	case 1:
		printf("Fase iniziale ? ");scanf("%lf",&phi0);
		printf("Tensione iniziale ? ");scanf("%lf",&v0);
		break;
	case 2:
		phi0 = 0;
		v0 = 0;
	}
printf("Phi(0) == %lf, V(0) == %lf\n",phi0,v0);

p=0;
y[0]= phi0;
y[1]= v0;
if(n_metodo == 1)
  Adams_start(0.0,y,mesh);
for(tau=0.0; tau<=vpst_trans; tau+=mesh)
  (*f_metodo)(tau,y,mesh);
for(tau=vpst_trans; tau<=vpst_mean+vpst_trans ; tau+=mesh)
  {
  (*f_metodo)(tau,y,mesh);
  if((p % p1) == 0)
   fprintf(output, "%.10lf\t%.10lf\t%.10lf\t%.10lf\n",tau,y[0],y[1],fmod(y[0],pi2));
  p++;
  }

fclose(output);
}

/* Polarizzazione con corrente i0+i1*sin(Omega1*tau) */
double f(double x, double y[], int i)
{
switch(i)
	{
	case 0: return(y[1]);
	case 1: return((i0+i1*sin(Omega1*x)-y[1]-sin(y[0]))/BetaC);
	};
}
