void RK4(double x, double y[], double h)
{
double h2 = h/2.0,h6 = h/6.0;
double xh = x + h, xh2 = x + h2;
double t1[NEQ],t2[NEQ],t3[NEQ],k1[NEQ],k2[NEQ],k3[NEQ],k4[NEQ];
int i;

for(i=0;i<NEQ;i++) 
	{
	k1[i]=f(x,y,i);
	t1[i]=y[i]+h2*k1[i];
	}
for(i=0;i<NEQ;i++)
	{ 
	k2[i]=f(xh2,t1,i);
	t2[i]=y[i]+h2*k2[i];
	}
for(i=0;i<NEQ;i++) 
	{
	k3[i]=f(xh2,t2,i);
	t3[i]=y[i]+h*k3[i];
	}
for(i=0;i<NEQ;i++) 
	{
	k4[i]=f(xh,t3,i);
	y[i]+=h6*(k1[i]+2*k2[i]+2*k3[i]+k4[i]);
	}
}

double F0[NEQ],F1[NEQ],F2[NEQ],F3[NEQ],F4[NEQ],F5[NEQ],Y1[NEQ];
double h90,h24,h12,h1440,h720;

void Adams_start(double x, double y[], double h)
{
double temp[NEQ];
int i;

h90 = h/90.0;
h24 = h/24.0;
h12 = h/12.0;
h720 = h/720.0;
h1440 = h/1440.0;

for(i=0; i<NEQ; i++)
	temp[i] = y[i];

RK4(x,y,-h);
for(i=0; i<NEQ; i++)
	{
	F1[i] = f(x,y,i);
	Y1[i] = y[i];
	}

RK4(x-h,y,-h);
for(i=0; i<NEQ; i++)
	F2[i] = f(x,y,i);

RK4(x-2*h,y,-h);
for(i=0; i<NEQ; i++)
	F3[i] = f(x,y,i);

RK4(x-3*h,y,-h);
for(i=0; i<NEQ; i++)
	F4[i] = f(x,y,i);

RK4(x-4*h,y,-h);
for(i=0; i<NEQ; i++)
	F5[i] = f(x,y,i);

for(i=0; i<NEQ; i++)
	y[i] = temp[i];
}

void Adams3(double x, double y[], double h)
{
int i;

for(i=0; i<NEQ ;i++)
	{
	F0[i] = f(x,y,i);
	y[i] += h12*(23*F0[i]-16*F1[i]+5*F2[i]);
	F2[i] = F1[i];
	F1[i] = F0[i];
	}
}

void Adams4(double x, double y[], double h)
{
int i;

for(i=0; i<NEQ ;i++)
	{
	F0[i] = f(x,y,i);
	y[i] += h24*(55*F0[i]-59*F1[i]+37*F2[i]-9*F3[i]);	
	F3[i] = F2[i];
	F2[i] = F1[i];
	F1[i] = F0[i];
	}
}

double Y0[NEQ];

void AdamsMoulton5(double x, double y[], double h)
{
int i;

for(i=0; i<NEQ ;i++)
	{
	F0[i] = f(x,y,i);
	Y0[i] = y[i];
	y[i] = Y1[i] + h90*(+29*F4[i]-146*F3[i]+294*F2[i]-266*F1[i]+269*F0[i]);
	Y1[i] = Y0[i];
	F4[i] = F3[i];
	F3[i] = F2[i];
	F2[i] = F1[i];
	F1[i] = F0[i];
	y[i] = Y0[i] + h720*(-19*F4[i]+106*F3[i]-264*F2[i]+646*F1[i]+251*f(x,y,i));
	}
}

void AdamsMoulton6(double x, double y[], double h)
{
int i;

for(i=0; i<NEQ ;i++)
	{
	F0[i] = f(x,y,i);
	Y0[i] = y[i];
	y[i] = Y1[i] + h90*(-28*F5[i]+169*F4[i]-426*F3[i]+574*F2[i]-406*F1[i]+297*F0[i]);
	Y1[i] = Y0[i];
	F5[i] = F4[i];
	F4[i] = F3[i];
	F3[i] = F2[i];
	F2[i] = F1[i];
	F1[i] = F0[i];
	y[i] = Y0[i] + h1440*(27*F5[i]-173*F4[i]+482*F3[i]-798*F2[i]+1427*F1[i]+475*f(x,y,i));
	}
}
